#!/bin/bash

function baked_flags()
{
    # support ZSH initializations
    if setopt &>/dev/null; then
        setopt local_options BASH_REMATCH
    fi

    # flags that were set during the build process
    # trailing spaces are intentional (see rematch regex below)
    local b_CXXFLAGS="-ftree-vectorize -fPIC -fstack-protector-strong -O2 -pipe -stdlib=libc++ -fvisibility-inlines-hidden -fmessage-length=0 -isystem /opt/civet0/build_0/_env/conda-bld/moose-mpi_1735973237402/_h_env_placehold_placehold_placehold_placehold_placehold_placehold_placehold_placehold_placehold_placehold_placehold_placehold_placehold_placehold_placehold_placehold_placehold_placehold_placehold/include -fdebug-prefix-map=/opt/civet0/build_0/_env/conda-bld/moose-mpi_1735973237402/work=/usr/local/src/conda/moose-mpi-base-2024.12.23 -fdebug-prefix-map=/opt/civet0/build_0/_env/conda-bld/moose-mpi_1735973237402/_h_env_placehold_placehold_placehold_placehold_placehold_placehold_placehold_placehold_placehold_placehold_placehold_placehold_placehold_placehold_placehold_placehold_placehold_placehold_placehold=/usr/local/src/conda-prefix "
    local b_CPPFLAGS="-D_FORTIFY_SOURCE=2 -isystem /opt/civet0/build_0/_env/conda-bld/moose-mpi_1735973237402/_h_env_placehold_placehold_placehold_placehold_placehold_placehold_placehold_placehold_placehold_placehold_placehold_placehold_placehold_placehold_placehold_placehold_placehold_placehold_placehold/include -mmacosx-version-min=11.3 "
    local b_CFLAGS="-ftree-vectorize -fPIC -fstack-protector-strong -O2 -pipe -isystem /opt/civet0/build_0/_env/conda-bld/moose-mpi_1735973237402/_h_env_placehold_placehold_placehold_placehold_placehold_placehold_placehold_placehold_placehold_placehold_placehold_placehold_placehold_placehold_placehold_placehold_placehold_placehold_placehold/include -fdebug-prefix-map=/opt/civet0/build_0/_env/conda-bld/moose-mpi_1735973237402/work=/usr/local/src/conda/moose-mpi-base-2024.12.23 -fdebug-prefix-map=/opt/civet0/build_0/_env/conda-bld/moose-mpi_1735973237402/_h_env_placehold_placehold_placehold_placehold_placehold_placehold_placehold_placehold_placehold_placehold_placehold_placehold_placehold_placehold_placehold_placehold_placehold_placehold_placehold=/usr/local/src/conda-prefix "
    local b_FFLAGS="-march=armv8.3-a -ftree-vectorize -fPIC -fno-stack-protector -O2 -pipe -isystem /opt/civet0/build_0/_env/conda-bld/moose-mpi_1735973237402/_h_env_placehold_placehold_placehold_placehold_placehold_placehold_placehold_placehold_placehold_placehold_placehold_placehold_placehold_placehold_placehold_placehold_placehold_placehold_placehold/include -fdebug-prefix-map=/opt/civet0/build_0/_env/conda-bld/moose-mpi_1735973237402/work=/usr/local/src/conda/moose-mpi-base-2024.12.23 -fdebug-prefix-map=/opt/civet0/build_0/_env/conda-bld/moose-mpi_1735973237402/_h_env_placehold_placehold_placehold_placehold_placehold_placehold_placehold_placehold_placehold_placehold_placehold_placehold_placehold_placehold_placehold_placehold_placehold_placehold_placehold=/usr/local/src/conda-prefix "
    local b_LDFLAGS="-Wl,-headerpad_max_install_names -Wl,-dead_strip_dylibs -Wl,-rpath,/opt/civet0/build_0/_env/conda-bld/moose-mpi_1735973237402/_h_env_placehold_placehold_placehold_placehold_placehold_placehold_placehold_placehold_placehold_placehold_placehold_placehold_placehold_placehold_placehold_placehold_placehold_placehold_placehold/lib -L/opt/civet0/build_0/_env/conda-bld/moose-mpi_1735973237402/_h_env_placehold_placehold_placehold_placehold_placehold_placehold_placehold_placehold_placehold_placehold_placehold_placehold_placehold_placehold_placehold_placehold_placehold_placehold_placehold/lib "

    # flags we are always interested in removing
    o_flags=('-std=c++[0-9][0-9]')

    # flags we are interested in removing when not performing a conda build
    # if we are not building packages (conda build), strip off CPU tuning
    if [[ -z "${CONDA_BUILD}" ]]; then
        if [[ $b_FFLAGS =~ (-march=[a-zA-Z0-9.-]+) ]]; then
            o_flags+=("${BASH_REMATCH[1]}")
        fi
        if [[ $b_FFLAGS =~ (-mtune=[a-zA-Z0-9.-]+) ]]; then
            o_flags+=("${BASH_REMATCH[1]}")
        fi
        # Lets assume this flag when used, is globbed together, separated by spaces
        if [[ $b_CXXFLAGS =~ (-fdebug-prefix-map=.* ) ]]; then
            o_flags+=("${BASH_REMATCH[1]}")
        fi

        # Offending flags we wish to remove
        o_flags+=('-D_FORTIFY_SOURCE=2' '-ftree-vectorize' '-DNDEBUG' '-O2' '-Wl,-dead_strip_dylibs' '-fno-stack-protector')
    fi

    # Remove any orphaned -Wl, flags (append last. Do not modify this line)
    o_flags+=('-Wl,[[:space:]]')

    for strip_flag in "${o_flags[@]}"; do
        if [[ -z "${strip_flag}" ]]; then continue; fi
        b_CXXFLAGS=${b_CXXFLAGS//${strip_flag}/}
        b_CPPFLAGS=${b_CPPFLAGS//${strip_flag}/}
        b_CFLAGS=${b_CFLAGS//${strip_flag}/}
        b_FFLAGS=${b_FFLAGS//${strip_flag}/}
        b_LDFLAGS=${b_LDFLAGS//${strip_flag}/}
    done

    # append necessary std c library
    export CXXFLAGS="${b_CXXFLAGS} -std=c++17"
    export CPPFLAGS=${b_CPPFLAGS}
    export CFLAGS=${b_CFLAGS}
    export FFLAGS=${b_FFLAGS}

    # specific OS linker flags
    LDFLAGS=${b_LDFLAGS}
    if [[ "$(uname)" == 'Darwin' ]]; then
        LDFLAGS+=" -Wl,-ld_classic -Wl,-commons,use_dylibs"
    fi
    export LDFLAGS
}

export CC=mpicc CXX=mpicxx FC=mpif90 F90=mpif90 F77=mpif77 C_INCLUDE_PATH=/opt/civet0/build_0/_env/conda-bld/moose-mpi_1735973237402/_h_env_placehold_placehold_placehold_placehold_placehold_placehold_placehold_placehold_placehold_placehold_placehold_placehold_placehold_placehold_placehold_placehold_placehold_placehold_placehold/include MOOSE_NO_CODESIGN=true MPIHOME=/opt/civet0/build_0/_env/conda-bld/moose-mpi_1735973237402/_h_env_placehold_placehold_placehold_placehold_placehold_placehold_placehold_placehold_placehold_placehold_placehold_placehold_placehold_placehold_placehold_placehold_placehold_placehold_placehold HDF5_DIR=/opt/civet0/build_0/_env/conda-bld/moose-mpi_1735973237402/_h_env_placehold_placehold_placehold_placehold_placehold_placehold_placehold_placehold_placehold_placehold_placehold_placehold_placehold_placehold_placehold_placehold_placehold_placehold_placehold

baked_flags
export OMPI_MCA_mca_base_component_show_load_errors=0
